/* 
 * File:   SingleValueSetting.h
 * Author: gruen
 *
 * Created on 29. Dezember 2010, 09:39
 */

#ifndef SINGLEVALUESETTING_H
#define	SINGLEVALUESETTING_H

#include <SettingBase.h>
#include <CLAExceptions.h>

namespace CommandLineArgumentLib {

template <class TValue>
class SingleValueSetting : public SettingBase {
public:
    typedef TValue(*ParseOptionValueFunction)(std::string);

    SingleValueSetting() {
        this->valid = false;
    };

    virtual ~SingleValueSetting() {
    };

    virtual void SetValue(std::string valueString) {
        this->valid = false;

        if (this->ParseValue == NULL)
            throw CLAException("ParseValue function not set in setting");

        this->value = this->ParseValue(valueString);
        this->valid = true;
    };

    TValue GetValue() const {
        return value;
    }

    virtual bool IsValid() const {
        return this->valid;
    }

    ParseOptionValueFunction ParseValue;
private:

    TValue value;
    bool valid;
};

}

#endif	/* SINGLEVALUESETTING_H */

