/* 
 * File:   CommandExecutor.cpp
 * Author: jochen
 * 
 * Created on 10. Januar 2011, 15:23
 */

#include <CommandExecutor.h>
#include <iostream>
#include <ShutdownException.h>

using namespace std;
using namespace media_transport_protocol;

CommandExecutor::CommandExecutor() {
}

CommandExecutor::CommandExecutor(const CommandExecutor& orig) {
}

CommandExecutor::~CommandExecutor() {
}

void CommandExecutor::Shutdown() {
    throw ShutdownException();
}

void CommandExecutor::PrintSockets() {
    socketConnector->PrintSockets();
}

void CommandExecutor::AddReceiverSocket(std::string senderIp, std::string receiverIp) {
    socketConnector->AddReceivingSocket(senderIp, receiverIp);
}

void CommandExecutor::AddSenderSocket(std::string senderIp, std::string receiverIp) {
    socketConnector->AddSendingSocket(senderIp, receiverIp);
}

void CommandExecutor::Reroute(int receiverSocketNo, int senderSocketNo) {
    socketConnector->ConnectSockets(receiverSocketNo, senderSocketNo);
}

void CommandExecutor::SetReceiverParameter(int socketIndex, media_transport_protocol::prrt_param* parameterObject){
    prrt_socket *socket = socketConnector->GetReceiverSocketList()->GetSocket(socketIndex);

    socket->set_param(*parameterObject);

    ostream &stream = controlCommunication->GetOutputStream();
    stream << "Setting receiver parameter " << parameterObject->get_file_name() << " to " << parameterObject->get_strvalue() << endl;
}

void CommandExecutor::SetSenderParameter(int socketIndex, media_transport_protocol::prrt_param* parameterObject){
    prrt_socket *socket = socketConnector->GetSenderSocketList()->GetSocket(socketIndex);

    socket->set_param(*parameterObject);

    ostream &stream = controlCommunication->GetOutputStream();
    stream << "Setting sender parameter " << parameterObject->get_file_name() << " to " << parameterObject->get_strvalue() << endl;
}

void CommandExecutor::SetOption(int socketIndex, media_transport_protocol::prrt_option* optionObject){
    prrt_socket *socket = socketConnector->GetSenderSocketList()->GetSocket(socketIndex);

    socket->setsockopt(*optionObject);

    ostream &stream = controlCommunication->GetOutputStream();
    stream << "Setting option " << optionObject->get_option() << " to " << optionObject->get_value() << endl;
}

