/* 
 * File:   SetParameterCommand.h
 * Author: jochen
 *
 * Created on 27. Januar 2011, 16:06
 */

#ifndef SETPARAMETERCOMMAND_H
#define	SETPARAMETERCOMMAND_H

#include <InputCommandBase.h>
#include <CommandExecutor.h>
#include <iostream>

template <class TParam>
class SetParameterCommand : public InputCommandBase {
public:

    SetParameterCommand() {
    }

    virtual ~SetParameterCommand() {
        if (this->parameterObject != 0)
            delete this->parameterObject;
    }

    void ReadParameters(std::istream& inputstream) {

        if (!(inputstream >> this->socketno).good()) {
            throw "Socket no not valid";
        }

    }

    virtual void Execute() {
        CommandExecutor *commandExecutor = GetCommandExecutor();

        (commandExecutor->*ExecuteFunction)(this->socketno, this->parameterObject);
    }

    TParam* GetParameterObject() const {
        return parameterObject;
    }

    voidExecutorFunctionIntParameter ExecuteFunction;

protected:

    void SetParameterObject(TParam* parameterObject) {
        if (this->parameterObject != 0)
            delete this->parameterObject;
        this->parameterObject = parameterObject;
    }

private:
    SetParameterCommand(const SetParameterCommand& orig);

    int socketno;
    TParam *parameterObject;
};

#endif	/* SETPARAMETERCOMMAND_H */

