/* 
 * File:   InputCommandBase.h
 * Author: jochen
 *
 * Created on 10. Januar 2011, 14:20
 */

#ifndef INPUTCOMMANDBASE_H
#define	INPUTCOMMANDBASE_H

#include <CommandExecutor.h>
#include <string>

class InputCommandBase {
public:
    InputCommandBase();

    virtual ~InputCommandBase();

    virtual void Execute() = 0;

    virtual void ReadParameters(std::istream& inputstream) = 0;

    bool IsParametersValid() const {
        return parametersValid;
    }

    void SetKey(std::string key) {
        this->key = key;
    }

    std::string GetKey() const {
        return key;
    }

    void SetCommandExecutor(CommandExecutor* commandExecutor) {
        this->commandExecutor = commandExecutor;
    }

    CommandExecutor* GetCommandExecutor() const {
        return commandExecutor;
    }

    void SetHelpMessage(std::string helpMessage) {
        this->helpMessage = helpMessage;
    }

    std::string GetHelpMessage() const {
        return helpMessage;
    }
private:
    InputCommandBase(const InputCommandBase& orig);

    CommandExecutor *commandExecutor;
    std::string key;
    bool parametersValid;
    std::string helpMessage;
};

#endif	/* INPUTCOMMANDBASE_H */

