/* 
 * File:   SocketList.cpp
 * Author: jochen
 * 
 * Created on 10. Januar 2011, 14:20
 */

#include <SocketList.h>
#include <iostream>
#include <sstream>

using namespace media_transport_protocol;
using namespace std;


SocketList::SocketList(string name) : name(name) {
}

SocketList::SocketList(const SocketList& orig) {
}

SocketList::~SocketList() {
    
}

void SocketList::PrintSockets(ostream &stream){
    stream << "Index  \tBound Sender IP    \tBound Receiver IP   \t"
         << "Connected Sender IP  \tConnected Receiver IP" << endl;
    
    for(int i=0; i<sockets.size(); i++){
        prrt_socket* socket = sockets[i];

        stream << "[" << i << "]:  \t" << socket->getBoundPeerAddr()
                << "   \t" << socket->getBoundSockAddr() << "   \t"
                << socket->getConnectedHostAddr() << "   \t"
                << socket->getConnectedSockAddr() << endl;
    }
}

prrt_socket *SocketList::GetSocket(int index){
    if(index >= sockets.size()) {
        stringstream ss;
        ss << "Socket with index " << index << " does not exist in " << name;
        throw ss.str().c_str();
    }

    return sockets.at(index);
}

void SocketList::AddSocket(prrt_socket* socket) {
    if(socket == 0)
        return;
    sockets.push_back(socket);
}

void SocketList::Shutdown() {
    for(int i=sockets.size()-1; i>=0; i--){
        prrt_socket *socket = sockets[i];
        sockets.pop_back();
        delete socket;
    }
}


