/*
 * (c) 2010 Saarland University, Telecommunications Lab
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 +
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 +
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 +
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 +
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 +
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device,
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#include <PrrtParseFunctions.h>
#include <sstream>

PrrtParseFunctions::PrrtParseFunctions()
{
}

PrrtParseFunctions::PrrtParseFunctions(const PrrtParseFunctions& orig)
{
}

PrrtParseFunctions::~PrrtParseFunctions()
{
}

StringUnsignedPair PrrtParseFunctions::ParseIpPort(std::string ipPortString) {
     int underlinePosition = ipPortString.find('_');
     std::string ipString = ipPortString.substr(0, underlinePosition);
     std::string portString = ipPortString.substr(underlinePosition+1, ipPortString.size());

     unsigned short port;
     std::stringstream ss(portString);
     if(!(ss >> port).eof()){
         throw CommandLineArgumentLib::CLAException("Could not parse Ip_Port");
     }

     return std::make_pair(ipString, port);
 }