#!/bin/sh

GAMMA=0.8
DELTA=0.05
SCALE=65535
COUNT=0
PREV_DATA=0
PREV_RI=0
PREV_LOST=0
RESRI=0
AINTERV=0
APLR=0.00

while [ -e "/proc/prrt/$1/stats" ]; do
QUERY=`cat /proc/prrt/$1/stats`

DATA=`echo "$QUERY" | grep "Sent data" | awk '{print $3}'`
RI=`echo "$QUERY" | grep "Sent redundancy" | awk '{print $3}'`
#RESLOSS=`echo "$QUERY" | grep "Missed packets" | awk '{print $3}'`
#LOST=`echo "$QUERY" | grep "Lost packets" | awk '{print $3}'`
#PLR=`echo "$QUERY" | grep "Last PLR" | awk '{print $3}'`
GPLR=`echo "$QUERY" | grep "Last GPLR" | awk '{print $3}'`
FTT=`echo "$QUERY" | grep "Last GFTT" | awk '{print $3}'`
#QDELAY=`echo "$QUERY" | grep "Queue Delay" | awk '{print $3}'`
#INTERV=`echo "$QUERY" | grep "Packet Interval" | awk '{print $3}'`
GRTT=`echo "$QUERY" | grep "Last GRTT" | awk '{print $3}'`
#WPLR=`echo "$QUERY" | grep "Worst PLR" | awk '{print $3}'`
#DELAY=`echo "$QUERY" | grep "Last decoding delay" | awk '{print $4}'`
GAPLENGTH=`echo "$QUERY" | grep "Gap GLength" | awk '{print $3}'`
BURSTLENGTH=`echo "$QUERY" | grep "Burst GLength" | awk '{print $3}'`
NUMGAPS=`echo "$QUERY" | grep "Num GGaps" | awk '{print $3}'`
NUMBURSTS=`echo "$QUERY" | grep "Num GBursts" | awk '{print $3}'`

DIFF_DATA=`echo "scale=8; $DATA-$PREV_DATA" | bc`

RESPLR=0
#if [ $DATA != 0 ]; then
#RESPLR=`echo "scale=8; $RESLOSS/$DATA" | bc`
#fi

if [ $DIFF_DATA != 0 ]; then
#RESRI=`echo "scale=8; $RI/$DATA" | bc`
RESRI=`echo "scale=8; $GAMMA*($RI-$PREV_RI)/($DIFF_DATA)+(1-$GAMMA)*$RESRI" | bc`
fi

#FPLR=`echo "scale=4; $PLR/$SCALE" | bc`
FGPLR=`echo "scale=4; $GPLR/$SCALE" | bc`
# FWPLR=`echo "scale=4; $WPLR/$SCALE" | bc`
#if [ $DIFF_DATA != 0 ]; then
#APLR=`echo "scale=4; $LOST/$DATA" | bc`
#APLR=`echo "scale=4; $GAMMA*($LOST-$PREV_LOST)/($DIFF_DATA)+(1-$GAMMA)*$APLR" | bc`
#fi

ALPHA=0.00
BETA=1.00
ABURST=0.00
if [ $NUMBURSTS != 0 ]; then
ABURST=`echo "scale=2; $BURSTLENGTH/$NUMBURSTS" | bc`
fi
if [ $BURSTLENGTH != 0 ]; then
ALPHA=`echo "scale=4; 1-$NUMBURSTS/$BURSTLENGTH" | bc`
fi
if [ $GAPLENGTH != 0 ]; then
BETA=`echo "scale=4; 1-$NUMGAPS/$GAPLENGTH" | bc`
fi
BETA=1.00

#AINTERV=`echo "scale=2; $DELTA*$INTERV+(1-$DELTA)*$AINTERV" | bc`

echo "`date "+%H:%M:%S"` $DATA $RI $APLR $ALPHA $BETA $ABURST $GRTT $FTT $RESRI"

PREV_DATA=$DATA
PREV_RI=$RI
PREV_LOST=$LOST

sleep 0.5
done
