#!/bin/bash

RECEIVERIP=134.96.86.20
SCALE=65535

#PLR values in %
PLR=( 4 5 6 7 8 9 10 15 20 25 )
PLR_NUM=${#PLR[@]}

DELAY=( 5 10 15 20 25 30 35 40 45 50 )
DELAY_NUM=${#DELAY[@]}

#RUNPRRTCAT="/home/eyobel/Source/PRRT/trunk/example/./prrtcat -j 4000 -ad 2 -code 200,2,1,1,1"
RUNPRRTRECV="/home/eyobel/Source/prrt/trunk/example/./prrtrecv 224.0.2.2 > /dev/null"
TEMP="/home/eyobel/Desktop/test.txt"


for (( i=0; i < $PLR_NUM; i++ ))
do
      for  (( j=0; j < $DELAY_NUM; j++ ))
      do
		
      		RTT=`echo "scale=4; ${DELAY[${j}]} * 2 " | bc`
		PLR_E=`echo "sclae=4; ${PLR[${i}]} / 100.0 " | bc -l`

		echo $PLR_E $RTT >> $TEMP

		#Optimum coding parameters from parameter calculation

		OPTIMUM=`/home/eyobel/Desktop/c_analysis_feedback/./PRPD_C 200 1 $PLR_E $RTT $PLR_E 0 0`
		DFEC=`echo "$OPTIMUM" | grep "D_FEC" | awk '{print $2}'`
		K_OPT=`echo "$OPTIMUM" | grep "k_opt" | awk '{print $2}'`
		NP=`echo "$OPTIMUM" | grep "Np_opt" | awk '{print $2}'`
		
		#Change the sender netem
		sudo tc qdisc change dev eth0 root netem loss ${PLR[${i}]}% delay ${DELAY[${j}]}ms
		#Change the receiver netem
		ssh -t $RECEIVERIP sudo tc qdisc change dev eth0 root netem loss ${PLR[${i}]}% delay ${DELAY[${j}]}ms
		
		#Start the sender and reciever
		/home/eyobel/Source/PRRT/trunk/example/./prrtcat -j 4000 -ad 0 -code 200,$DFEC,$K_OPT$NP &
		echo "./prrtcat -j 4000 -ad 0 -code 200,$DFEC,$K_OPT$NP" >> $TEMP 
		
		ssh $RECEIVERIP $RUNPRRTRECV &

		sleep 1
		
		# Get socket number at the receiver
		QUERYRCV=`ssh $RECEIVERIP ls /proc/prrt`
		SOCKETRCV=`echo "$QUERYRCV" | egrep "[0-9]{1,}" -o`

		PRRTRCVPROC=`ssh 134.96.86.20 ps ax | grep prrtrecv | awk '{print $1}'`

		#Start evalscript and save output to file
		EVALSCRIPT="/home/eyobel/Source/prrt/trunk/example/./evalscript.sh $SOCKETRCV"
		ssh $RECEIVERIP $EVALSCRIPT >> $TEMP &
		
		sleep 120
	
		#kill the processes prrtcat and prrtrecv
		PRRTCAT=`ps -a | grep "lt-prrtcat" | awk '{print $1}'`
		kill -15 $PRRTCAT
		
		SSHNUM=`ps -a | grep "ssh" | awk '{print $1}'`
		kill -15 $SSHNUM

		ssh 134.96.86.20 kill -15 $PRRTRCVPROC
		#delete receiver socket
		#DELSOCKET="echo delete $SOCKETRCV > /proc/prrt/register"
		#ssh $RECEIVERIP $DELSOCKET  

		#delete sender socket
		QUERYTX=`ls /proc/prrt`
		SOCKETTX=`echo "$QUERYTX" | egrep "[0-9]{1,}" -o`

		if [ -e "/proc/prrt/$SOCKETTX/stats" ]
		then 
			echo "delete $SOCKETTX" > /proc/prrt/register
		fi


		#sleep 5

     done

done		
