/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef MPT_OPTION_BASE_H
#define MPT_OPTION_BASE_H

#include <string>

namespace media_transport_protocol {

/// This is the base class for all options that a prrt_socket supports.
/// This class should not be used, use the derived classes.
/// To use options you can simply create an object for the required option
/// and give it a value when defining it.
class prrt_option {
	protected:
		int value;		/// The value for the option.
		std::string option;	/// The string containing the option name.

	public:
		/// This function returns the plain string for this function for communication
		/// purposes with the kernel module.
		std::string get_option() const { return option; };

		/// This functions returns the value that was set for the option.
		int get_value() const { return value; };
};

}

#endif /*MPT_OPTION_BASE_H*/
