/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#include "socket_list.h"
#include <stdlib.h>

using namespace media_transport_protocol;

socket_list::socket_list()
{
}

socket_list::~socket_list()
{
}

void socket_list::add(prrt_socket *socket)
{
	sock_list.push_front(socket);
}

prrt_socket *socket_list::del_rnd()
throw(list_error)
{
	if(sock_list.empty())
		throw(list_error("List is empty!"));

	prrt_socket *sock = sock_list.front();
	sock_list.pop_front();

	return sock;
}

void socket_list::del(prrt_socket *socket)
{
	std::list<prrt_socket *>::iterator iter;

	for(iter=sock_list.begin(); iter!=sock_list.end(); iter++) {
		if((*iter) == socket) {
			sock_list.erase(iter);
			return;
		}
	}
}
