/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef KUI_OPTION_H
#define KUI_OPTION_H

#include "../defines.h"

enum option_t {
	NONE,		/*this describes that no event has happened yet*/
	FEEDBACK,	/*option to deactivate the sending of feedback(receiver)*/
  DECODE, 	/*option to deactivate the decoding of feedback(receiver)*/
	REPLACE,	/*this is the option to deactivate the replacement sending(sender)*/
	CODING,		/*option to deactivate coding in general(sender)*/
  GATHER_FEEDBACK,/*this states whether feedback should be gathered(sender)*/
  TIMEOUT,        /*should receiving be stopped after a timeout(receiver)*/
  PRRT_RCVBUF,    /*The buffer size of the socket used in the transmission between a pair of PRRT sockets is set to a specific value.*/
  KERNEL_RCVBUF,  /*The buffer size of the socket used in the kernel space of the kernel-user communication is set to a specific value.*/
  USER_RCVBUF,    /*The buffer size of the socket used in the user space of the kernel-user communication is set to a specific value.*/
  TRAFFICSHAPING, /*The data rate for the traffic shaping is set to a specific value.*/
  FB_SUPP_ON      /*The option to enable feedback suppression at the receiver.*/
};

enum option_val_t {
	OFF = 0,
	ON = 1
};

void *kui_create_option_file(Socketno_t socketno);

void kui_delete_option_file(Socketno_t socketno);

#endif /*KUI_OPTION_H*/

