/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#include <linux/init.h>
#include <linux/module.h>

MODULE_LICENSE("Dual MPL/GPL");

#include "kui/kernel_user_interface.h"

static int prrt_init(void)
{
	PDEBUG(MSG_INIT, "PRRT is in da House!\n");

	kui_init_proc_interface();

	return 0;
}

static void prrt_exit(void)
{
// 	u32 t1 = 1;
	//u32 t1 = 2147483648ul+1ul;
// 	u32 t1 = 2147483648ul/2-1ul;
// 	u32 t2 = 2147483648ul/2*3+1ul;
	//u32 t2 = 2147483648ul-1ul;
// 	u32 t2 = 4294967295ul;
// 	int cmp;

	kui_uninit_proc_interface();

	PDEBUG(MSG_INIT, "PRRT is leaving da House...\n");

	PDEBUG(MSG_TEST, "PRRT: Tests\n");
	PDEBUG(MSG_TEST, "PRRT: ----------------------------\n");
	PDEBUG(MSG_TEST, "PRRT: HZ = %d\n", HZ);
}

module_init(prrt_init);
module_exit(prrt_exit);
