/* 
 * (c) 2010 Saarland University, Telecommunications Lab 
 * (prrt@nt.uni-saarland.de)
 *
 * The contents of this file are subject to the Mozilla Public License
 + Version 1.1 (the "License"); you may not use this file except in
 + compliance with the License. You may obtain a copy of the License at
 + http://www.mozilla.org/MPL/
 + 
 + Software distributed under the License is distributed on an "AS IS"
 + basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 + License for the specific language governing rights and limitations
 + under the License.
 + 
 + The Original Code is "Predictably Reliable Real-time Transport (PRRT)".
 + 
 + The Initial Developer of the Original Code is Saarland University.
 + All Rights Reserved.
 + 
 + Contributor(s): Jochen Gruen (Saarland University), Manuel Gorius
 + (Saarland University), Yongtao Shuai (Saarland University).
 + 
 + Disclaimer: This Alpha version of PRRT is not supported and stable yet.
 + Do not use it in a production environment: it may crash your device, 
 + so please make sure that you have a backup of your data before
 + installing PRRT.
 */

#ifndef PROC_ACCESS_H
#define PROC_ACCESS_H

/**
 * Function to write to a procfile.
 * \param filepath absolute path to the file to write to.
 * \param command the command that should be written to the procfile.
 * \param clen the length of the command in bytes.
 * \return 0 on success, -1 if an error occurs.
 */
int proc_write(const char* filepath, char *command, int clen);

/**
 * Function to read from a procfile.
 * \param filepath absolute path to the file to write to.
 * \param feedback buffer for the feedback that is coming from the procfile.
 * \param clen the length of the buffer in bytes.
 * \return number of read bytes on success, -1 if an error occurs.
 */
int proc_read(const char* filepath, char *feedback, int flen);

#endif /* PROC_ACCESS_H*/
